/******************************************************************************
Store_ems.c
Stores full 512X512 image in EMS and in file if requested with name.
      Image Acquisition & Display Program - Primitive Control Functions
                       Runs on any VGA or MCGA display.
 Displays the image with the serial register on the right edge of the screen.
******************************************************************************/
#include <bios.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <at200.h>
#include <at200oem.h>
#include <camera.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>

    ems_handle = 0;                   /* the ems handle */
    unsigned far *data;               /* pointer to ems data page */
    char *fname;                      /* Pointer to output file */
    int dofile = 0;

char far *screen_row[200] = { 0, };   /* Pointers to graphics display rows */
/* screen_row[] is initialized in main() to point to the start of each row on
   the VGA display.  It is then used by the show_image() function to update
   the VGA memory. */

void show_image(void)
{
unsigned char buff[320];
unsigned max,min,page,row;
register int x,y;
long z;
unsigned count;
int fd;

  for( y=8192,x=0,z=0,page=0 ; z<262144 ; y++,z++ ) {
  	if(y >= 8192) {
  		ems_map_page(0,ems_handle,page++);
  		y -=8192;
      printf(" %d data[y]=%d , data=%d\n",x++,data[y+20],*data);
  	}
  }
/* write buffer to file picture
      if(dofile) {
	fd = open(fname,O_WRONLY | O_CREAT |O_BINARY , S_IREAD | S_IWRITE);

  for( page=0 ; page<32 ; page) {
  ems_map_page(0,ems_handle,page++);
	count=write(fd,*data,16*1024);
        }
	close(fd);
}
*/
}

void main()
{
ems_handle = ems_alloc( 262144 * sizeof(unsigned) );
if( !ems_handle ) {
	printf("Unable to allocate EMS. Unable to procede.\n");
	exit(3);
}
data=(unsigned *) ems_get_page_frame(); /* Returns pointer to EMS page frame. */
printf(" data = %Fx \n",data);
if( !data ) {
	printf("Unable to locate EMS page frame. Unable to procede.\n");
	exit(4);
}
    show_image();
  ems_free( ems_handle );
  exit( 0 );
}

